#ifndef COUPLINGS_h
#define COUPLINGS_h
/**************************************************/
/*  class to evaluate the user defined couplings  */
/**************************************************/
//----------------
#include "Moses.h"
//----------------
#include "parameters.h"
#include "mosesParticle.h"
#include "gellMannMatrices.h"

using namespace std;

namespace Moses1 {

class couplings {
	public:
		couplings();
		couplings(physicalParameters &physPrm);
		virtual ~couplings();
		// to return the couplings of a fermion with helicity lambda=+1/2 to Z0/gamma gauge bosons
		virtual double getCouplings(double helicity,
					pdtParticle &propagator, customParticle &fermion,
					physicalParameters &physPrm);
		
		virtual double getCouplings(unsigned int nMode, double helicity,
					pdtParticle &propagator, customParticle &fermion,
					physicalParameters &physPrm);

					
		virtual dcomplex  getMassiveGlounSchannelCouplings(unsigned int Lambda_I,unsigned int nMode, double helicity1, double helicity2,
									  pdtParticle &propagator,  customParticle &fermion1,customParticle &fermion2,
									  physicalParameters &physPrm);
	
// new functions
		int getFlavorIndex(int index){ return flavorIndex[abs(index)]; };
		virtual dcomplex  getFGBqQbarCouplings(pdtParticle &propagator, physicalParameters &physPrm, unsigned int Lambda_I,
								customParticle &qfermion, double qhelicity, customParticle &Qfermion, double Qhelicity);		
		virtual void setFGBqQbarCouplings(physicalParameters &physPrm);
		virtual void printFGBqQbarCouplings();
		virtual int getFGBgroup(customParticle &qfermion, double qhelicity, customParticle &Qfermion, double Qhelicity);

		virtual dcomplex  couplings::getFGBqQbarCouplingsbyIndex(physicalParameters &physPrm, unsigned int Lambda_I,
								int qfermion, double qhelicity, int Qfermion, double Qhelicity);
	private:
		gellMannMatrices gMatrix;
// new arrays
		
		double FGBCouplingsQQbar[18];
		//{PDTDWN (1) ,PDTUP(2),PDTSTR(3),PDTCHM(4),PDTBOT(5),PDTTOP(6),PDTE,PDTMU,PDTTAU,PDTNUE,PDTNUMU,PDTNUTAU}		
				        //1,2,3,4,5,6 
		int flavorIndex[6];		
		dcomplex  FGBVertexCouplingsArray[2][6][6][8];//[Helicity][inFer][outFer][Lambda]
									
};

}
#endif
