#ifndef HELICITYAMPLITUDE_h
#define HELICITYAMPLITUDE_h
/************************************************************/
/* class to evaluate the user defined helicity amplitude    */
/* the function here is taken from the "Z LINE SHAPE" paper */
/************************************************************/
//----------------
#include "Moses.h"
//----------------
#include "parameters.h"
#include "mosesParticle.h"
#include "couplings.h"


using namespace std;

namespace Moses1 {

	class helicityAmplitude : public couplings {
	public:
		
		helicityAmplitude();
		
		virtual ~helicityAmplitude();

		// to return the regular [qqbar ---> gamma*/Z0 ---> ffbar] helicityAmplitude
		virtual dcomplex gethelicityAmplitude(double s, double totalWidth_s,
							double inHelicity, double outHelicity,
							customParticle &inFermion, customParticle &outFermion,
							pdtParticle &propagator, physicalParameters &physPrm);
		
		// to return the [qqbar ---> Kaluz-Klein gamma/Z0 n'th mode 'n'=0,1,2,... ---> ffbar] helicityAmplitude
		virtual dcomplex gethelicityAmplitude(unsigned int mMode, double s, double totalWidth_s,
							double inHelicity, double outHelicity,
							customParticle &inFermion, customParticle &outFermion,
							pdtParticle &propagator, physicalParameters &physPrm);

		
		// to return the [qqbar ---> gloun  --> ffbar] helicityAmplitude
                virtual dcomplex helicityAmplitude::gethelicitySMglounAmplitude(double s, pdtParticle &propagator, physicalParameters &physPrm,
										       customParticle &outFermion1);

		// to return the [qqbar ---> Kaluz-Klein RS1 type Gloun_{Gell man Metrix - lambda(x ; 1-8)_Group(Ql as 1 ,Ur as 2 , Dr as 3)}  --> ffbar] helicityAmplitude
                virtual dcomplex helicityAmplitude::gethelicityMassiveGAmplitude(unsigned int Lambda_I,unsigned int nMode,
										 double s, double  totalWidth_s,
										 double inHelicity1,double inHelicity2,
										 double outHelicity1, double outHelicity2,
										 customParticle &inFermion1, customParticle &inFermion2,
										 customParticle &outFermion1, customParticle &outFermion2,
										 pdtParticle &propagator, physicalParameters &physPrm,couplings &Gcouplings);

dcomplex helicityAmplitude::getFGBTChannelHelicityAmplitude(unsigned int Lambda_I,unsigned int nMode,double t,
										 double inHelicity1,double inHelicity2,
										 double outHelicity1, double outHelicity2,
										 customParticle &inFermion1, customParticle &inFermion2,
										 customParticle &outFermion1, customParticle &outFermion2,
										 pdtParticle &propagator, physicalParameters &physPrm,couplings &Gcouplings);

};
}
										 
#endif
