/************************************************************/
/* class to Define the gell mann matrices   with            */
/*          Tr(i,j) = 1 * delata(i,j)                       */
/************************************************************/
#include "Moses.h"
#include "gellMannMatrices.h"

using namespace std;

namespace Moses1 {

// this class inherit functions from the "GellMannMatices" class

gellMannMatrices::gellMannMatrices(){}
gellMannMatrices::~gellMannMatrices(){}

void gellMannMatrices::SetGellMannMatrices() {

	dcomplex img (0,1.);
	dcomplex RealC (1.,0);
	// Size of the Static Lambda matrix
    Lambda.resize(9);
	for(int i = 0; i < 9; i++){
		Lambda[i].resize(3);
		for(int j = 0; j < 3; j++)
		  Lambda[i][j].resize(3);
	 }

	dcomplex Lambda1[3][3] = {{0.             ,1.0/sqrt(2.0)  ,0},
							  {1.0/sqrt(2.0)  ,0			  ,0},
							  {0	  		  ,0	 		  ,0}
									};

	dcomplex Lambda2[3][3] = {{0. 		      ,-1.0*img/sqrt(2.0)  ,0.},
							  {img/sqrt(2.0)  ,0.  			       ,0.},
							  {0.    		  ,0.		           ,0.}
									};

	dcomplex Lambda3[3][3] = {{RealC/sqrt(2.)   ,0.              ,0.},
							  {0.              ,-RealC/sqrt(2.)  ,0.},
							  {0.              ,0.              ,0.}
    								};

	dcomplex Lambda4[3][3] = {{0.			,0.        ,RealC/sqrt(2.)},
							  {0.			,0.		   ,0.},
							  {RealC/sqrt(2.)	,0.   	   ,0.}
									};

	dcomplex Lambda5[3][3] = {{0.			  ,0.   ,-img/sqrt(2.0)},
							  {0.          	  ,0.   ,0.},
							  {img/sqrt(2.0)  ,0.   ,0.}
									};

	dcomplex Lambda6[3][3] = {{0.	   ,0. 			 ,.0},
							  {0.      ,0. 			 ,RealC/sqrt(2.0)},
							  {0.      ,RealC/sqrt(2.0) ,.0}
									};

	dcomplex Lambda7[3][3] = {{0.	   ,0.              ,.0},
							  {0.      ,0.  	        ,-img/sqrt(2.0)},
							  {0.      ,img/sqrt(2.0)   ,.0}
									};

 	dcomplex Lambda8[3][3] = {{RealC/sqrt(6.0)  ,0.             ,0.},
							  {0.           ,RealC/sqrt(6.0)   ,0.},
							  {0.           ,0.             ,-2.0*RealC/sqrt(6.0)}
									};

	for (int i = 0; i<3;i++){
						for (int j = 0; j<3;j++){
							Lambda[0][i][j] = 0;
						}
				}

    setMatrix(1,Lambda1);
    setMatrix(2,Lambda2);
    setMatrix(3,Lambda3);
    setMatrix(4,Lambda4);
    setMatrix(5,Lambda5);
    setMatrix(6,Lambda6);
    setMatrix(7,Lambda7);
    setMatrix(8,Lambda8);

 }




 void gellMannMatrices::setMatrix(int index, dcomplex Matrix[3][3]){
 	for (int i = 0; i<3;i++){
 		for (int j = 0; j<3;j++){
 			Lambda[index][i][j] = Matrix[i][j];
 		}
 	}

}

}


