// Example of how to read a moses run record file with gamma/Z^0 ->mu+mu- events
TFile* f = NULL;

TTree* runSummaryTree = NULL;
TTree* controlTree = NULL;

/*
TTree* muonTree       = NULL;
TTree* electronTree   = NULL;
TTree* photonTree     = NULL;
TTree* neutrinoTree   = NULL;
TTree* mesonTree      = NULL;
TTree* baryonTree     = NULL;
TTree* clusterJetTree = NULL;
TTree* cellJetTree    = NULL;
*/

TH1D* hid       = NULL;
TH1D* hmass     = NULL;
TH1D* hpT       = NULL;
TH1D* heta      = NULL;
TH1D* hcostheta = NULL;
TH2D* hxyvtx    = NULL;
TH1D* hzvtx     = NULL;
TH1D* hemiss    = NULL;
TH1D* hetmiss   = NULL;
TH1D* hchgmult  = NULL;
TH1D* hphonrg   = NULL;
TH1D* hclusjet_p0        = NULL;
TH1D* hclusjet_pT        = NULL;
TH1D* hcelljet_p0Massive = NULL;
TH1D* hcelljet_pTMassive = NULL;
TH1D* hcelljet_etaCenter = NULL;
TH1D* hcelljet_phiCenter = NULL;
TH1D* hcelljet_eT        = NULL;
TH1D* hcelljet_mult      = NULL;

TCanvas* cid       = NULL;
TCanvas* cmass     = NULL;
TCanvas* cpT       = NULL;
TCanvas* ceta      = NULL;
TCanvas* ccostheta = NULL;
TCanvas* cvtx      = NULL;
TCanvas* cemiss    = NULL;
TCanvas* cchgmult  = NULL;
TCanvas* cphonrg   = NULL;
TCanvas* cclusjet  = NULL;
TCanvas* ccelljet  = NULL;

TVirtualPad* pemiss  = NULL;
TVirtualPad* petmiss = NULL;
TVirtualPad* pvtx    = NULL;
TVirtualPad* pclusjet_p0        = NULL;
TVirtualPad* pclusjet_pT        = NULL;
TVirtualPad* pcelljet_p0Massive = NULL;
TVirtualPad* pcelljet_pTMassive = NULL;
TVirtualPad* pcelljet_eT        = NULL;



void readTree()
{
	TString filename = "/srv01/tau/hod/moses-1.2.0/data/mosesRunRecord.root";
	TFile *f = new TFile(filename);
	
	f->cd("runControl");
    runSummaryTree = (TTree *)f->Get("runControl/runHeaderTree");
    controlTree = (TTree *)f->Get("runControl/controlTree");

	/*
	// now make friends of the master tree
	controlTree->AddFriend("muon/muonTree", f);
	controlTree->AddFriend("electron/electronTree", f);
	controlTree->AddFriend("photon/photonTree", f);
	controlTree->AddFriend("neutrino/neutrinoTree", f);
	controlTree->AddFriend("meson/mesonTree", f);
	controlTree->AddFriend("baryon/baryonTree", f);
	controlTree->AddFriend("ClusterJet/ClusterJetTree", f);
	controlTree->AddFriend("CellJet/CellJetTree", f);
	*/
	
	/*
	f->cd("muon");
	muonTree     = (TTree *)f->Get("muon/muonTree");
	f->cd("electron");
	electronTree = (TTree *)f->Get("electron/electronTree");
	f->cd("photon");
	photonTree   = (TTree *)f->Get("photon/photonTree");
	f->cd("neutrino");
	neutrinoTree = (TTree *)f->Get("neutrino/neutrinoTree");
	f->cd("meson");
	mesonTree    = (TTree *)f->Get("meson/mesonTree");
	f->cd("baryon");
	baryonTree   = (TTree *)f->Get("baryon/baryonTree");
	
	f->cd("ClusterJet");
	clusterJetTree = (TTree *)f->Get("ClusterJet/ClusterJetTree");
	f->cd("CellJet");
	cellJetTree    = (TTree *)f->Get("CellJet/CellJetTree");
	*/
	
	//muonTree->Draw("p0");
	//muonTree->Draw("mu_pt","evt_diMuonMass>10");
	//muonTree->Draw("mu_cosTheta","mu_pt>10");
}


void bookHistos()
{
	cid = new TCanvas("id","id",800,600);
    hid = new TH1D("id","id", 40, -20., 20.);	

	cmass = new TCanvas("mass","mass",800,600);
    cmass->SetLogy();
	hmass = new TH1D("mass","mass", 40, 0., 200.);

	cpT = new TCanvas("pT","pT",800,600);
    cpT->SetLogy();
	hpT = new TH1D("pT","pT", 40, 0., 200.);

	ceta = new TCanvas("eta","eta",800,600);
	heta = new TH1D("eta","eta", 30, -15., 15.);

	ccostheta = new TCanvas("costheta","costheta",800,600);	
	hcostheta = new TH1D("cos#theta","cos#theta", 10, -1., 1.);

	cvtx = new TCanvas("vertex","vertex",800,600);
	cvtx->Divide(1,2);
	hxyvtx = new TH2D("xyvtx","xyvtx", 50, -1.e1, 1.e1,  50, -1.e1, 1.e1);
	pvtx  = cvtx->cd(2);
	pvtx->SetLogy();
	hzvtx = new TH1D("zvtx","zvtx", 50, -1.e1, 1.e1);
	
	cemiss = new TCanvas("emiss","emiss",800,600);
	cemiss->Divide(1,2);
	pemis  = cemiss->cd(1);
	pemis->SetLogy();
	petmis = cemiss->cd(2);
	petmis->SetLogy();
    hemiss = new TH1D("emiss","E^{miss}", 40, 0., 200.);
	hetmiss = new TH1D("etmiss","E_{T}^{miss}", 40, 0., 200.);
	
	cchgmult = new TCanvas("chargemult","chargemult",800,600);
	cchgmult->SetLogy();
    hchgmult = new TH1D("chargemult","#frac{dN_{ch}}{dp_{T}}", 25, 0., 50.);

	cphonrg = new TCanvas("photonEnergy","photonEnergy",800,600);
    cphonrg->SetLogy();
    hphonrg = new TH1D("photonEnergy","E_{#gamma}", 50, 0., 400.);
	
	cclusjet = new TCanvas("ClusterJet","ClusterJet",800,600);
	cclusjet->Divide(1,2);
	pclusjet_p0 = cclusjet->cd(1);
	pclusjet_p0->SetLogy();
	pclusjet_pT = cclusjet->cd(2);
	pclusjet_pT->SetLogy();
    hclusjet_p0 = new TH1D("Eclusterjet","E^{ClusterJet}", 40, 0., 200.);
	hclusjet_pT = new TH1D("pTclusterjet","p_{T}^{ClusterJet}", 40, 0., 200.);

	
	ccelljet = new TCanvas("CellJet","CellJet",800,600);
	ccelljet->Divide(2,3);
	pcelljet_p0Massive = ccelljet->cd(1);
	pcelljet_p0Massive->SetLogy();
	pcelljet_pTMassive = ccelljet->cd(2);
	pcelljet_pTMassive->SetLogy();
	pcelljet_eT = ccelljet->cd(5);
	pcelljet_eT->SetLogy();
    hcelljet_p0Massive = new TH1D("Ecelljet(massive)","E^{CellJet(massive)}", 40, 0., 200.);
	hcelljet_pTMassive = new TH1D("pTcelljet(massive)","p_{T}^{CellJet(massive)}", 40, 0., 200.);
	hcelljet_etaCenter = new TH1D("etacelljet","#eta^{CellJet}_{center}", 20, -10., 10.);
	hcelljet_phiCenter = new TH1D("phicelljet","#phi^{CellJet}_{center}", 24, -4., 4.);
	hcelljet_eT        = new TH1D("eTcelljet","E_{T}^{CellJet}", 40, 0., 200.);
	hcelljet_mult      = new TH1D("jetmultiplicity","JetMultiplicity^{CellJet}", 40, 0., 100.);
}


void drawHistos()
{
	cid->Draw();
	cid->cd();
	hid->Draw();

	cmass->Draw();
	cmass->cd();
	hmass->Draw();

	cpT->Draw();
	cpT->cd();
	hpT->Draw();

	ceta->Draw();
	ceta->cd();
	heta->Draw();

	ccostheta->Draw();
	ccostheta->cd();
	hcostheta->Draw();

	cvtx->Draw();
	cvtx->cd();
	cvtx->cd(1);
	hxyvtx->Draw("BOX");
	cvtx->cd(2);
	hzvtx->Draw();

	cemiss->Draw();
	cemiss->cd();
	cemiss->cd(1);
	hemiss->Draw();
	cemiss->cd(2);
	hetmiss->Draw();

	cchgmult->Draw();
	cchgmult->cd();
	hchgmult->Draw();

	cphonrg->Draw();
	cphonrg->cd();
	hphonrg->Draw();
	
	cclusjet->Draw();
	cclusjet->cd();
	cclusjet->cd(1);
	hclusjet_p0->Draw();
	cclusjet->cd(2);
	hclusjet_pT->Draw();

	ccelljet->Draw();
	ccelljet->cd();
	ccelljet->cd(1);
	hcelljet_p0Massive->Draw();
	ccelljet->cd(2);
	hcelljet_pTMassive->Draw();
	ccelljet->cd(3);
	hcelljet_etaCenter->Draw();
	ccelljet->cd(4);
	hcelljet_phiCenter->Draw();
	ccelljet->cd(5);
	hcelljet_eT->Draw();
	ccelljet->cd(6);
	hcelljet_mult->Draw();	
}


double mass(vector<double>& pa, double ma, vector<double>& pb, double mb)
{
	return sqrt( ma*ma + mb*mb + 2.*( pa[0]*pb[0] - pa[1]*pb[1] - pa[2]*pb[2] - pa[3]*pb[3]) );
}


double pT(vector<double>& p)
{
	return sqrt(p[1]*p[1] + p[2]*p[2]);
}


double pAbs(vector<double>& p)
{
	return sqrt(p[1]*p[1] + p[2]*p[2] + p[3]*p[3]);
}


double QT(vector<double>& pa, vector<double>& pb)
{
	return sqrt( (pa[1]+pb[1])*(pa[1]+pb[1]) + (pa[2]+pb[2])*(pa[2]+pb[2]) );
}


double eta(vector<double>& p)
{
	double pabs = pAbs(p);
	return 0.5*log( (pabs+p[3]) / (pabs-p[3]) );
}


double y(vector<double>& p)
{
	return 0.5*log( (p[0]+p[3]) / (p[0]-p[3]) );
}


double ySystem(vector<double>& pa, vector<double>& pb) 
{
        return  0.5*log( ((pa[0]+pb[0]) + (pa[3]+pb[3])) / ((pa[0]+pb[0]) - (pa[3]+pb[3])) );
}


double cosThetaCollinsSoper(vector<double>& pa, double ma, vector<double>& pb, double mb)
{
        double mass2 = mass(pa,ma, pb,mb)*mass(pa,ma, pb,mb);
        double QT2 = QT(pa,pb)*QT(pa,pb);
        double cosThetaCS = 2.*( pa[3]*pb[0] - pa[0]*pb[3] ) / sqrt( mass2 * (mass2 + QT2) );
        if (ySystem(pa,pb) < 0) { cosThetaCS *= -1.; } // reclassify
        return cosThetaCS;
}


bool cutVtx(vector<double>& vtxa, vector<double>& vtxb, double dR)
{
	double dRa = sqrt(vtxa[0]*vtxa[0] + vtxa[1]*vtxa[1]);
	double dRb = sqrt(vtxb[0]*vtxb[0] + vtxb[1]*vtxb[1]);
	//cout << "dRa=" << dRa << ", dRb=" << dRb << endl;
	if( dRa <= dR  &&  dRb <= dR) return true;
	return false;
}



void printHeader(int errors)
{
        vector<int>* beams_id;
        vector<double>* beams_m0;
        vector<double>* beams_p0;
        vector<double>* beams_pz;
        vector<string>* sProcessName;
        vector<int>*    nProcessCode;
        double eCM;
        int nEvents;
        //string sProcessName;
        //int nProcessCode;
        int nTried, nSelected, nAccepted;
        double sigma_mb, sigmaErr_mb;
        double mHatMin, mHatMax;
        runSummaryTree->SetBranchAddress("beamParticle_id", &beams_id);
        runSummaryTree->SetBranchAddress("beamParticle_m0", &beams_m0);
        runSummaryTree->SetBranchAddress("beamParticle_p0", &beams_p0);
        runSummaryTree->SetBranchAddress("beamParticle_pz", &beams_pz);
        runSummaryTree->SetBranchAddress("eCM",          &eCM);
        runSummaryTree->SetBranchAddress("nEvents",      &nEvents);
        runSummaryTree->SetBranchAddress("sProcessName", &sProcessName);
        runSummaryTree->SetBranchAddress("nProcessCode", &nProcessCode);
        runSummaryTree->SetBranchAddress("nTried",       &nTried);
        runSummaryTree->SetBranchAddress("nSelected",    &nSelected);
        runSummaryTree->SetBranchAddress("nAccepted",    &nAccepted);
        runSummaryTree->SetBranchAddress("sigma_mb",     &sigma_mb);
        runSummaryTree->SetBranchAddress("sigmaErr_mb", &sigmaErr_mb);
        runSummaryTree->SetBranchAddress("mHatMin", &mHatMin);
        runSummaryTree->SetBranchAddress("mHatMax", &mHatMax);

        runSummaryTree->GetEntry(0);

        cout << "\n\n--------------------- begin run header ---------------------" << endl;
        if(errors>0) cout << "all errors in file: " << errors << endl;
        cout << "beam A id: " << (*beams_id)[0] << endl;
        cout << "\t m=" << (*beams_m0)[0] << endl;
        cout << "\t E=" << (*beams_p0)[0] << endl;
        cout << "\t pz=" << (*beams_pz)[0] << endl;
        cout << "beam B id: " << (*beams_id)[1] << endl;
        cout << "\t m=" << (*beams_m0)[1] << endl;
        cout << "\t E=" << (*beams_p0)[1] << endl;
        cout << "\t pz=" << (*beams_pz)[1] << endl;
        cout << "process (codes):" << endl;
        for(int p=0 ; p<nProcessCode->size() ; p++)
        {
                cout << "\tprocess[" << p << "]: " << (*sProcessName)[0] << " (" << (*nProcessCode)[0] << ")" << endl;
        }
        cout << "events:" << endl;
        cout << "\tnEvents(user): " << nEvents << endl;
        cout << "\tnTried: " << nTried << endl;
        cout << "\tnSelected: " << nSelected << endl;
        cout << "\tnAccepted: " << nAccepted << endl;
        cout << "cross section:" << endl;
        cout << "\tsigma[mb]: " << sigma_mb << " +- " << sigmaErr_mb << endl;
        cout << "\tE CM: " << eCM << endl;
        cout << "\tmHat min: " << mHatMin << endl;
        cout << "\tmHat max: " << mHatMax << endl;
        cout << "---------------------- end run header ----------------------\n\n" << endl;
}




// An example of how to access the muonTree/ntuple variables
void eventLoop()
{
	readTree();
	bookHistos();

	// control
	int nMuons, nElectrons, nPhotons, nNeutrinos, nMesons, nBaryons, nClusterJets, nCellJets;
	controlTree->SetBranchAddress("Nmuons",       &nMuons);
	controlTree->SetBranchAddress("Nelectrons",   &nElectrons);
	controlTree->SetBranchAddress("Nphotons",     &nPhotons);
	controlTree->SetBranchAddress("Nneutrinos",   &nNeutrinos);
	controlTree->SetBranchAddress("Nmesons",      &nMesons);
	controlTree->SetBranchAddress("Nbaryons",     &nBaryons);
	controlTree->SetBranchAddress("NClusterJets", &nClusterJets);
	controlTree->SetBranchAddress("NCellJets",    &nCellJets);

	// muons
	vector<int>* isHardProcess;
	vector<int>* id;
	vector<double>* cg;
	vector<double>* m0;
	vector<double>* p0;
	vector<double>* px;
	vector<double>* py;
	vector<double>* pz;
	vector<double>* xVtx;
	vector<double>* yVtx;
	vector<double>* zVtx;
	controlTree->SetBranchAddress("muon/muonTree.isHardProcess",&isHardProcess);
	controlTree->SetBranchAddress("muon/muonTree.id",&id);
	controlTree->SetBranchAddress("muon/muonTree.cg",&cg);
	controlTree->SetBranchAddress("muon/muonTree.m0",&m0);
	controlTree->SetBranchAddress("muon/muonTree.p0",&p0);
	controlTree->SetBranchAddress("muon/muonTree.px",&px);
	controlTree->SetBranchAddress("muon/muonTree.py",&py);
	controlTree->SetBranchAddress("muon/muonTree.pz",&pz);
	controlTree->SetBranchAddress("muon/muonTree.xVtx",&xVtx);
	controlTree->SetBranchAddress("muon/muonTree.yVtx",&yVtx);
	controlTree->SetBranchAddress("muon/muonTree.zVtx",&zVtx);
	
	// neutrinos
    vector<double>* nu_p0;
	vector<double>* nu_px;
	vector<double>* nu_py;
	vector<double>* nu_pz;
    controlTree->SetBranchAddress("neutrino/neutrinoTree.p0",&nu_p0);
	controlTree->SetBranchAddress("neutrino/neutrinoTree.px",&nu_px);
	controlTree->SetBranchAddress("neutrino/neutrinoTree.py",&nu_py);
	controlTree->SetBranchAddress("neutrino/neutrinoTree.pz",&nu_pz);

	// electrons
	vector<double>* el_p0;
	vector<double>* el_px;
	vector<double>* el_py;
	vector<double>* el_pz;
	controlTree->SetBranchAddress("electron/electronTree.p0",&el_p0);
	controlTree->SetBranchAddress("electron/electronTree.px",&el_px);
	controlTree->SetBranchAddress("electron/electronTree.py",&el_py);
	controlTree->SetBranchAddress("electron/electronTree.pz",&el_pz);	

	// photons
	vector<double>* pho_p0;
	controlTree->SetBranchAddress("photon/photonTree.p0",&pho_p0);

	// mesons
	vector<double>* mes_cg;
	vector<double>* mes_p0;
	vector<double>* mes_px;
	vector<double>* mes_py;
	vector<double>* mes_pz;
	controlTree->SetBranchAddress("meson/mesonTree.cg",&mes_cg);
	controlTree->SetBranchAddress("meson/mesonTree.p0",&mes_p0);
	controlTree->SetBranchAddress("meson/mesonTree.px",&mes_px);
	controlTree->SetBranchAddress("meson/mesonTree.py",&mes_py);
	controlTree->SetBranchAddress("meson/mesonTree.pz",&mes_pz);

	// baryons
	vector<double>* bar_cg;
	vector<double>* bar_p0;
	vector<double>* bar_px;
	vector<double>* bar_py;
	vector<double>* bar_pz;
	controlTree->SetBranchAddress("baryon/baryonTree.cg",&bar_cg);
	controlTree->SetBranchAddress("baryon/baryonTree.p0",&bar_p0);
	controlTree->SetBranchAddress("baryon/baryonTree.px",&bar_px);
	controlTree->SetBranchAddress("baryon/baryonTree.py",&bar_py);
	controlTree->SetBranchAddress("baryon/baryonTree.pz",&bar_pz);
	
	// ClusterJet
	vector<double>* clusjet_p0;
	vector<double>* clusjet_px;
	vector<double>* clusjet_py;
	vector<double>* clusjet_pz;
	controlTree->SetBranchAddress("ClusterJet/ClusterJetTree.p0",&clusjet_p0);
	controlTree->SetBranchAddress("ClusterJet/ClusterJetTree.px",&clusjet_px);
	controlTree->SetBranchAddress("ClusterJet/ClusterJetTree.py",&clusjet_py);
	controlTree->SetBranchAddress("ClusterJet/ClusterJetTree.pz",&clusjet_pz);
	
	// CellJet
	vector<double>* celljet_p0;
	vector<double>* celljet_px;
	vector<double>* celljet_py;
	vector<double>* celljet_pz;
	vector<double>* celljet_etaCenter;
	vector<double>* celljet_phiCenter;
	vector<double>* celljet_eT;
	vector<int>* celljet_mult;
	controlTree->SetBranchAddress("CellJet/CellJetTree.p0",&celljet_p0);
	controlTree->SetBranchAddress("CellJet/CellJetTree.px",&celljet_px);
	controlTree->SetBranchAddress("CellJet/CellJetTree.py",&celljet_py);
	controlTree->SetBranchAddress("CellJet/CellJetTree.pz",&celljet_pz);
	controlTree->SetBranchAddress("CellJet/CellJetTree.etaCenter",&celljet_etaCenter);
	controlTree->SetBranchAddress("CellJet/CellJetTree.phiCenter",&celljet_phiCenter);
	controlTree->SetBranchAddress("CellJet/CellJetTree.eT",&celljet_eT);
	controlTree->SetBranchAddress("CellJet/CellJetTree.multiplicity",&celljet_mult);
	

	double m0a, m0b;
	vector<double> pa, pb, pnu, pel, pmes, pbar, pclusterjet, pcelljet;
	vector<double> vtx, vtxa, vtxb;
	int na, nb;
	int NA=NB=0;

	for (int i=0 ; i<controlTree->GetEntries() ; i++)
	{
		controlTree->GetEntry(i);

		cout << "\nevt: " << i+1 << ":" << endl;
		cout << "\tnMuons: " << nMuons << endl;
		cout << "\tnElectrons: " << nElectrons << endl;
		cout << "\tnPhotons: " << nPhotons << endl;
		cout << "\tnNeutrinos: " << nNeutrinos << endl;
		cout << "\tnMesons: " << nMesons << endl;
		cout << "\tnBaryons: " << nBaryons << endl;
		cout << "\tnClusterJets: " << nClusterJets << endl;
		cout << "\tnCellJets: " << nCellJets << endl;

		// muons
		if (nMuons>0)
		{
			na=nb=0;
			for (int j=0 ; j<nMuons ; j++)
			{
				if( (*isHardProcess)[j]>0. )
				//if(true)
				{
					if( (*id)[j] > 0 )
					{
						na++;
						m0a = (*m0)[j];
						pa.clear();
						pa.push_back( (*p0)[j] ); // or: pa.push_back( p0->at(j) );
						pa.push_back( (*px)[j] );
						pa.push_back( (*py)[j] );
						pa.push_back( (*pz)[j] );
						vtxa.clear();
						vtxa.push_back( (*xVtx)[j] );
						vtxa.push_back( (*yVtx)[j] );
						vtxa.push_back( (*zVtx)[j] );
					}
					else
					{
						nb++;
						m0b = (*m0)[j];
						pb.clear();
						pb.push_back( (*p0)[j] ); // or: pb.push_back( p0->at(j) );
						pb.push_back( (*px)[j] );
						pb.push_back( (*py)[j] );
						pb.push_back( (*pz)[j] );
						vtxb.clear();
						vtxb.push_back( (*xVtx)[j] );
						vtxb.push_back( (*yVtx)[j] );
						vtxb.push_back( (*zVtx)[j] );
					}
					double dR = 1.e-6;
					if( na>=1 && nb>=1 && cutVtx(vtxa, vtxb, dR) )
					{
						double m = mass(pa, m0a, pb, m0b);
						hmass->Fill( m );
						hpT->Fill( pT(pa) );
						heta->Fill( eta(pa) );
						if(m>=75. && m<=115.) hcostheta->Fill( cosThetaCollinsSoper(pa, m0a, pb, m0b) );
					}
				}

				hid->Fill( (*id)[j] );
				
				vtx.clear();
				vtx.push_back( (*xVtx)[j] );
				vtx.push_back( (*yVtx)[j] );
				vtx.push_back( (*zVtx)[j] );
				hxyvtx->Fill( vtx[0], vtx[1] );
				hzvtx->Fill( vtx[2] );
			}
			NA+=na;
			NB+=nb;
		}

		// neutrinos
		if(nNeutrinos>0)
		{
			for (int j=0 ; j<nNeutrinos ; j++)
			{
				pnu.clear();
				pnu.push_back( (*nu_p0)[j] ); // or: pb.push_back( p0->at(j) );
				pnu.push_back( (*nu_px)[j] );
				pnu.push_back( (*nu_py)[j] );
				pnu.push_back( (*nu_pz)[j] );
				hemiss->Fill( pnu[0] );
				hetmiss->Fill( pT(pnu) );
			}
		}
		
		// electrons
		if(nElectrons>0)
        {

			for (int j=0 ; j<nElectrons ; j++)
			{
				pel.clear();
				pel.push_back( (*el_p0)[j] ); // or: pb.push_back( p0->at(j) );
				pel.push_back( (*el_px)[j] );
				pel.push_back( (*el_py)[j] );
				pel.push_back( (*el_pz)[j] );
				hchgmult->Fill( pT(pel) );
			}
        }
	
		// photons
        if(nPhotons>0)
        {         
			for (int j=0 ; j<nPhotons ; j++)
			{
				hphonrg->Fill( (*p0)[j] );
			}
        }

		// mesons
		if(nMesons>0)
		{
			for (int j=0 ; j<nMesons ; j++)
			{
				bool isCharged = ( (*mes_cg)[j] != 0 ) ? true : false;
				if(isCharged)
				{
					pmes.clear();
					pmes.push_back( (*mes_p0)[j] ); // or: pb.push_back( p0->at(j) );
					pmes.push_back( (*mes_px)[j] );
					pmes.push_back( (*mes_py)[j] );
					pmes.push_back( (*mes_pz)[j] );
					hchgmult->Fill( pT(pmes) );
				}
			}
		}

		// baryons
		if(nBaryons>0)
		{
			for (int j=0 ; j<nBaryons ; j++)
			{
				bool isCharged = ( (*bar_cg)[j] != 0 ) ? true : false;
				if(isCharged)
				{
					pbar.clear();
					pbar.push_back( (*bar_p0)[j] ); // or: pb.push_back( p0->at(j) );
					pbar.push_back( (*bar_px)[j] );
					pbar.push_back( (*bar_py)[j] );
					pbar.push_back( (*bar_pz)[j] );
					hchgmult->Fill( pT(pbar) );
				}
			}
		}
		
		// clusterJets
        if(nClusterJets>0)
		{
			for (int j=0 ; j<nClusterJets ; j++)
			{
				pclusterjet.clear();
				pclusterjet.push_back( (*clusjet_p0)[j] ); // or: pb.push_back( p0->at(j) );
				pclusterjet.push_back( (*clusjet_px)[j] );
				pclusterjet.push_back( (*clusjet_py)[j] );
				pclusterjet.push_back( (*clusjet_pz)[j] );
					
				hclusjet_p0->Fill( (*clusjet_p0)[j] );
				hclusjet_pT->Fill( pT(pclusterjet) );
			}
		}
		
		// cellJets
        if(nCellJets>0)
		{
			for (int j=0 ; j<nCellJets ; j++)
			{
				pcelljet.clear();
				pcelljet.push_back( (*celljet_p0)[j] ); // or: pb.push_back( p0->at(j) );
				pcelljet.push_back( (*celljet_px)[j] );
				pcelljet.push_back( (*celljet_py)[j] );
				pcelljet.push_back( (*celljet_pz)[j] );
					
				hcelljet_p0Massive->Fill( (*celljet_p0)[j] );
				hcelljet_pTMassive->Fill( pT(pcelljet) );
				hcelljet_etaCenter->Fill( (*celljet_etaCenter)[j] );
				hcelljet_phiCenter->Fill( (*celljet_phiCenter)[j] );
				hcelljet_eT->Fill( (*celljet_eT)[j] );
				hcelljet_mult->Fill( (*celljet_mult)[j] );
			}
		}
	}
	drawHistos();
	printHeader(0);
	cout << "NA=" << NA << ", NB=" << NB << endl;
}

